<%@ Page Language="vb" Async="true" AutoEventWireup="true" Debug="true"  %>

<%@ Import Namespace="System.Threading.Tasks" %>

<%@ Import Namespace="System.Net" %>

<%@ Import Namespace="System.Net.Sockets" %>

<%@ Import Namespace="System.IO" %>



<script runat="server" language="vb">



  Public Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs)


	'RegisterAsyncTask(new PageAsyncTask(DoSendRequest));

	'RegisterAsyncTask(new PageAsyncTask(Button1_Click));

  End Sub



  Private async Function SendRequest(ByVal server As String, ByVal port As Integer, ByVal method As String, ByVal data As String) As Task(Of String)


	Try


	  ' determine IP address of server

	  Dim ipAddress As IPAddress = Nothing

	  Dim ipHostInfo As IPHostEntry = System.Net.Dns.GetHostEntry(server)

	  For i As Integer = 0 To ipHostInfo.AddressList.Length - 1


		If ipHostInfo.AddressList(i).AddressFamily = AddressFamily.InterNetwork Then


		  ipAddress = ipHostInfo.AddressList(i)

		  Exit For

		End If

	  Next i

	  If ipAddress Is Nothing Then

		Throw New Exception("No IPv4 address for server")
	  End If



	  Dim client As New TcpClient()

	  await client.ConnectAsync(ipAddress, port) ' connect to the server



	  Dim networkStream As NetworkStream = client.GetStream()

	  Dim writer As New StreamWriter(networkStream)

	  Dim reader As New StreamReader(networkStream)



	 writer.AutoFlush = True

	  Dim requestData As String = "method=" & method & "&" & "data=" & data & "&eor" ' 'end-of-requet'

	  await writer.WriteLineAsync(requestData)

	  Dim response As String = await reader.ReadLineAsync()



	  client.Close()



	  Return response




	Catch ex As Exception


	  Return ex.Message

	End Try

  End Function ' SendRequest



  Private async Sub Button1_Click(ByVal sender As Object, ByVal e As System.EventArgs)


	Try


	  Dim server As String = "VTE.redmond.corp.microsoft.com"

	  Dim port As Integer = 50000

	  Dim method As String = TextBox1.Text

	  Dim data As String = TextBox2.Text



	  Dim sResponse As String = await SendRequest(server, port, method, data)

	  Dim dResponse As Double = Double.Parse(sResponse)

	  TextBox3.Text = dResponse.ToString("F2")






	Catch ex As Exception


	  TextBox3.Text = ex.Message

	End Try



  End Sub

</script>



<head>

	<title>Demo</title>

</head>



<body>

	<form id="form1" runat="server">

	<div>



	<p>Enter service method: <asp:TextBox ID="TextBox1" runat="server"></asp:TextBox></p>

	<p>Enter data: <asp:TextBox ID="TextBox2" runat="server"></asp:TextBox></p>

	<p><asp:Button Text="Send Request" id="Button1" runat="server"  OnClick="Button1_Click"> </asp:Button> </p>

	<p>Response: <asp:TextBox ID="TextBox3" runat="server"></asp:TextBox></p>

	<p>Dummy responsive control: <asp:TextBox ID="TextBox4" runat="server"></asp:TextBox></p>



	</div>

	</form>



</body>

</html>